/********************************************************************************************
 *
 * Copyright 2012-2018  Frank Gollnik  <http://www.jabotics.org>
 *
 * 
 * This file is part of the Java software package org.jabotics (in the following: Jabotics).
 * 
 * Jabotics is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Jabotics is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jabotics.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * Diese Datei ist Teil des Java-Software-Pakets org.jabotics (im Folgenden kurz: Jabotics).
 * 
 * Jabotics ist Freie Software: Sie können es unter den Bedingungen
 * der GNU General Public License, wie von der Free Software Foundation,
 * Version 3 der Lizenz oder (nach Ihrer Wahl) jeder späteren
 * veröffentlichten Version, weiterverbreiten und/oder modifizieren.
 * 
 * Jabotics wird in der Hoffnung, dass es nützlich sein wird, aber
 * OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 * Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
 * Siehe die GNU General Public License für weitere Details.
 * 
 * Sie sollten eine Kopie der GNU General Public License zusammen mit Jabotics
 * erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************************/


package org.jabotics.robot.en;


/**
 * <span class="advanced">&bull;</span> The class XRobot provides some class variables including
 * an instance of the object factory that is necessary to instantiate all further objects for
 * controlling a robot. For details on the object factory see {@link IObjectFactory}.
 * 
 * @author  Frank Gollnik
 * @version 1.2.1
 */
public class XRobot
{

    /**
     * <span class="beginner">&bull;</span> Constant to reduce typing effort in classes
     * derived from XRobot (use START instead of EWaitingMode.START).
     */
    static final public EWaitingMode START = EWaitingMode.START;

    /**
     * <span class="beginner">&bull;</span> Constant to reduce typing effort in classes
     * derived from XRobot (use WAIT instead of EWaitingMode.WAIT).
     */
    static final public EWaitingMode WAIT = EWaitingMode.WAIT;

    /**
     * <span class="beginner">&bull;</span> Constant to reduce typing effort in classes
     * derived from XRobot (use FORWARD instead of EDirection.FORWARD).
     */
    static final public EDirection FORWARD = EDirection.FORWARD;

    /**
     * <span class="beginner">&bull;</span> Constant to reduce typing effort in classes
     * derived from XRobot (use BACKWARD instead of EDirection.BACKWARD).
     */
    static final public EDirection BACKWARD = EDirection.BACKWARD;

    /**
     * <span class="beginner">&bull;</span> Constant to reduce typing effort in classes
     * derived from XRobot (use FLUTE instead of ESound.FLUTE).
     */
    static final public ESound FLUTE = ESound.FLUTE;

    /**
     * <span class="beginner">&bull;</span> Constant to reduce typing effort in classes
     * derived from XRobot (use PIANO instead of ESound.PIANO).
     */
    static final public ESound PIANO = ESound.PIANO;

    /**
     * <span class="beginner">&bull;</span> Constant to reduce typing effort in classes
     * derived from XRobot (use XYLOPHONE instead of ESound.XYLOPHONE).
     */
    static final public ESound XYLOPHONE = ESound.XYLOPHONE;

    /**
     * <span class="advanced">&bull;</span> The object factory to create all objects necessary to control the robot.
     */
    static final public IObjectFactory objectFactory = new XObjectFactory();
    
    protected XRobot() {}
}
