/********************************************************************************************
 *
 * Copyright 2012-2018  Frank Gollnik  <http://www.jabotics.org>
 *
 * 
 * This file is part of the Java software package org.jabotics (in the following: Jabotics).
 * 
 * Jabotics is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Jabotics is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jabotics.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * Diese Datei ist Teil des Java-Software-Pakets org.jabotics (im Folgenden kurz: Jabotics).
 * 
 * Jabotics ist Freie Software: Sie können es unter den Bedingungen
 * der GNU General Public License, wie von der Free Software Foundation,
 * Version 3 der Lizenz oder (nach Ihrer Wahl) jeder späteren
 * veröffentlichten Version, weiterverbreiten und/oder modifizieren.
 * 
 * Jabotics wird in der Hoffnung, dass es nützlich sein wird, aber
 * OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 * Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
 * Siehe die GNU General Public License für weitere Details.
 * 
 * Sie sollten eine Kopie der GNU General Public License zusammen mit Jabotics
 * erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************************/


package org.jabotics.test.core;

import org.jabotics.robot.defs.*;
import org.jabotics.robot.core.*;
import org.jabotics.robot.adapter.XAdapter;
import org.jabotics.robot.util.XLogBuffer;

/**
 * Beschreiben Sie hier die Klasse AdaptTest201505.
 * 
 * @author  Frank Gollnik
 * @version 1.2.1
 */
public class AdaptTest201505
{
    static public void main(String[] args)
    {
        try
        {
            ITimerAdapter timer = XAdapter.getFactory().getTimerAdapter();
            XLogBuffer.enableLogging(true);
    
            /*CMotor motor1 = CMotor.getMotor(1);
            CMotor motor2 = CMotor.getMotor(2);
            ATimer.msDelay(4000);
            motor1.startRotationUnlimited(null,true);
            CMotor.execute(null,motor1,false);
            ATimer.msDelay(4000);
            motor2.startRotationTimeLimited(null,8000f,true);
            CMotor.execute(null,motor2,false);
            ATimer.msDelay(4000);
            motor1.startRotationUnlimited(null,false);
            CMotor.execute(null,motor1,false);
            ATimer.msDelay(10000);
            motor1.stopRotation(null);
            CMotor.execute(null,motor1,true);
            ATimer.msDelay(2000);*/
    
            timer.msDelay(2000);
            CPilot pilot = CPilot.getPilotSingleton(EMotorPort.B,EMotorPort.C);
            pilot.moveStraight(50f, true);
            pilot.rotateByAngle(180f, true);
            pilot.moveArc(50f, 180f, true);
            timer.msDelay(2000);
        }
        catch (Exception e)
        {
            synchronized(XLogBuffer.getMonitor())
            {
                XLogBuffer.print("Exception in Thread: ");
                XLogBuffer.println(Thread.currentThread().getName());
                XLogBuffer.print("Message: ");
                XLogBuffer.println(e.getMessage());
            }
        }
        finally
        {
            XLogBuffer.enableLogging(false);
            IConsoleAdapter console = XAdapter.getFactory().getConsoleAdapter();
            console.open();
            console.print(XLogBuffer.flush());
            console.close();
        }
    }
}
