/********************************************************************************************
 *
 * Copyright 2012-2018  Frank Gollnik  <http://www.jabotics.org>
 *
 * 
 * This file is part of the Java software package org.jabotics (in the following: Jabotics).
 * 
 * Jabotics is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Jabotics is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jabotics.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * Diese Datei ist Teil des Java-Software-Pakets org.jabotics (im Folgenden kurz: Jabotics).
 * 
 * Jabotics ist Freie Software: Sie können es unter den Bedingungen
 * der GNU General Public License, wie von der Free Software Foundation,
 * Version 3 der Lizenz oder (nach Ihrer Wahl) jeder späteren
 * veröffentlichten Version, weiterverbreiten und/oder modifizieren.
 * 
 * Jabotics wird in der Hoffnung, dass es nützlich sein wird, aber
 * OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 * Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
 * Siehe die GNU General Public License für weitere Details.
 * 
 * Sie sollten eine Kopie der GNU General Public License zusammen mit Jabotics
 * erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************************/


package org.jabotics.test.robot;

import org.jabotics.robot.de.*;

/**
 * Beschreibe hier die Klasse SimTest201505.
 * 
 * @author  Frank Gollnik
 * @version 1.2.1
 */
public class SimTest201505 extends XRoboter
{
    static final IMotor linkerMotor = XRoboter.objektfabrik.erzeugeMotor(EMotoranschluss.C);
    static final IMotor rechterMotor = XRoboter.objektfabrik.erzeugeMotor(EMotoranschluss.B);
    static final IPilot pilot = XRoboter.objektfabrik.erzeugePiloten(EMotoranschluss.C, EMotoranschluss.B);
    static final ITastsensor eingabetaste = XRoboter.objektfabrik.erzeugeTastsensor(ETaster.EINGABE);
    static final ITastsensor endetaste = XRoboter.objektfabrik.erzeugeTastsensor(ETaster.ENDE);
    static final ITastsensor linkstaste = XRoboter.objektfabrik.erzeugeTastsensor(ETaster.LINKS);
    static final ITastsensor rechtstaste = XRoboter.objektfabrik.erzeugeTastsensor(ETaster.RECHTS);
    static final ITastsensor tastsensor = XRoboter.objektfabrik.erzeugeTastsensor(ESensoranschluss.S1);
    static final ISensor schallsensor = XRoboter.objektfabrik.erzeugeSchallsensor(ESensoranschluss.S2);
    static final ILichtsensor lichtsensor = XRoboter.objektfabrik.erzeugeLichtsensor(ESensoranschluss.S3);
    static final ISensor ultraschallsensor = XRoboter.objektfabrik.erzeugeUltraschallsensor(ESensoranschluss.S4);
    static final IUhr uhr = XRoboter.objektfabrik.erzeugeUhr();
    static final IMonitor monitor = XRoboter.objektfabrik.erzeugeMonitor();
    static final ILautsprecher lautsprecher = XRoboter.objektfabrik.erzeugeLautsprecher();
 
    public static void main(String[] args)
    {
        //XLogBuffer.enableLogging(true);
        //uhr.warteZeit(2000); // Zeit, um die Hand nach dem Programmstart aus dem Weg zu nehmen
        /*monitor.schreibe("1 ÄßCDEFGHIJKLMN",0,0,true);
        monitor.schreibe("XX\nXXXX\nXXX\nXXX",6,5,true);
        uhr.warteZeit(4000);
        monitor.schreibe("2 ABCDEFGHIJKLMN",0,1);
        monitor.schreibe("3 ABCDEFGHIJKLMN",0,2);
        monitor.schreibe("4 ABCDEFGHIJKLMN",0,3);
        monitor.schreibe("5 ABCDEFGHIJKLMN",0,4);
        monitor.schreibe("6 ABCDEFGHIJKLMN",0,5);
        monitor.schreibe("7 ABCDEFGH\nIJKLMN",0,6,true);
        uhr.warteZeit(4000);
        monitor.loescheZeile(3);
        uhr.warteZeit(4000);
        monitor.loescheZeichen(10,4,10);
        uhr.warteZeit(4000);
        monitor.schreibe(123456789,0,0);
        monitor.schreibe(123456789,12,1);
        uhr.warteZeit(4000);
        float pi = (float) Math.PI;
        monitor.schreibe(pi,3,2);
        float fl = (float) (Math.PI * 123456789012345.0);
        monitor.schreibe(fl,0,7);
        monitor.schreibe(fl,13,6);
        uhr.warteZeit(4000);
        monitor.loescheAlles();
        uhr.warteZeit(4000);
        monitor.schreibe("1 ÄßCDEFGHIJKLMN\n",0,0);
        monitor.schreibe("2 ABCDEFGHIJKLMN\n",0,1);
        monitor.schreibe("3 ABCDEFGHIJKLMN\n",0,2);
        monitor.schreibe("4 ABCDEFGHIJKLMN\n",0,3);
        monitor.schreibe("5 ABCDEFGHIJKLMN\n",0,4);
        monitor.schreibe("6 ABCDEFGHIJKLMN\n",0,5);
        monitor.schreibe("7 ABCDEFGH\nIJKLMN\n",0,6);
        uhr.warteZeit(4000);
        monitor.schreibe("XX\nXXXX\nXXX\nXXX",6,5,true);
        monitor.schreibe(1234,0,1,2);
        monitor.schreibe(2345,0,2,6);
        monitor.schreibe(1234,0,3,18);*/
        /*for (int k = 0;  k < 10;  ++k)
        {
            lichtsensor.schalteLichtEin();
            uhr.warteZeit(100);
            int helligkeitEin = lichtsensor.holeMesswert();
            lichtsensor.schalteLichtAus();
            uhr.warteZeit(100);
            int helligkeitAus = lichtsensor.holeMesswert();
            monitor.schreibe(k,0,0,3);
            monitor.schreibe(". (Ein): ",3,0);
            monitor.schreibe(helligkeitEin,12,0,4);
            monitor.schreibe(k,0,1,3);
            monitor.schreibe(". (Aus): ",3,1);
            monitor.schreibe(helligkeitAus,12,1,4);
            uhr.warteZeit(1000);
        }
        for (int k = 0;  k < 100;  ++k)
        {
            uhr.warteZeit(100);
            int helligkeit = lichtsensor.holeMesswert();
            int abstand = ultraschallsensor.holeMesswert();
            monitor.schreibe(k,0,0,3);
            monitor.schreibe(". Hllgk: ",3,0);
            monitor.schreibe(helligkeit,12,0,4);
            monitor.schreibe(k,0,1,3);
            monitor.schreibe(". Abstd: ",3,1);
            monitor.schreibe(abstand,12,1,4);
            uhr.warteZeit(1000);
        }*/
        lautsprecher.spieleBeep();
        lautsprecher.spielePause(1000);
        lautsprecher.spieleBuzz();
        lautsprecher.spielePause(1000);
        lautsprecher.spieleBeepfolge();
        monitor.loescheAlles();
        monitor.schreibe("Bitte",5,2);
        monitor.schreibe("Eingabetaste",2,3);
        monitor.schreibe("druecken!",3,4);
        eingabetaste.warteBisGedrueckt();
        monitor.loescheAlles();
        monitor.schreibe("Und",6,2);
        monitor.schreibe("jetzt",5,3);
        monitor.schreibe("klatschen!",3,4);
        schallsensor.warteBisGrenzwertUeberschritten(80);
        //rechterMotor.setzeKorrekturfaktorWinkelstand(1.005f);
        pilot.setzeSollgeschwindigkeit(30);
        pilot.setzeSollbeschleunigung(60);
        pilot.dreheUmWinkel(-140,ABWARTEN);
        pilot.fahreRadius(-200,RUECKWAERTS);
        tastsensor.warteBisGedrueckt();
        pilot.halteAn(ABWARTEN);
        uhr.warteZeit(1000);
        pilot.fahreGerade(40,ABWARTEN);
        /*pilot.fahreBogen(-70, -90, ABWARTEN);
        pilot.fahreGerade(150,ABWARTEN);*/
        /*pilot.fahreBogen((float)Math.PI * 5, -180, ABWARTEN);
        pilot.fahreGerade(290,ABWARTEN);
        pilot.fahreBogen((float)Math.PI * 60, 180, ABWARTEN);
        pilot.fahreGerade(100,ABWARTEN);
        pilot.fahreBogen((float)Math.PI * 30, -90, ABWARTEN);
        pilot.fahreBogen((float)Math.PI * 60, 180, ABWARTEN);
        pilot.fahreBogen((float)Math.PI * 30, -90, ABWARTEN);
        pilot.fahreBogen(600,180,ABWARTEN);
        pilot.fahreGerade(200,ABWARTEN);*/
        uhr.warteZeit(2000);
        //XLogBuffer.enableLogging(false);
        /*AConsole.open();
        AConsole.print(XLogBuffer.flush());
        AConsole.close();*/
    }
}
